Index: orxonox/branches/openAL/src/story_entities/world.h
===================================================================
--- orxonox/branches/openAL/src/story_entities/world.h	(revision 3921)
+++ orxonox/branches/openAL/src/story_entities/world.h	(revision 4194)
@@ -11,5 +11,5 @@
 #include "story_entity.h"
 #include "p_node.h"
-
+#include "xmlparser/tinyxml.h"
 
 class World;
@@ -19,7 +19,6 @@
 class PNode;
 class GLMenuImageScreen;
-class Skysphere;
-class SkyBox;
 class LightManager;
+class ParticleEngine;
 class Terrain;
 class GarbageCollector;
@@ -57,4 +56,5 @@
   World (char* name);
   World (int worldID);
+  World (TiXmlElement* root);
   virtual ~World ();
 
@@ -70,4 +70,6 @@
   virtual ErrorMessage resume ();
   virtual ErrorMessage destroy ();
+
+  void loadDebugWorld(int worldID);
 
   virtual void displayLoadScreen();
@@ -85,10 +87,13 @@
 	     int parentingMode);
 
+  const char* getPath();
+  void setPath( const char* name);
 
  private:
-  void init(char* name, int worldID);
+  void constuctorInit(char* name, int worldID);
 
   Uint32 lastFrame;                   //!< last time of frame
   Uint32 dt;                          //!< time needed to calculate this frame
+  float dtS;                          //!< The time needed for caluculations in seconds
   double gameTime;                    //!< this is where the game time is saved
   bool bQuitOrxonox;                  //!< quit this application
@@ -100,10 +105,11 @@
   char* worldName;                    //!< The name of this World
   int debugWorldNr;                   //!< The Debug Nr. needed, if something goes wrong
+  char* path;                         //!< The file from which this world is loaded
 
   PNode* nullParent;                  //!< The zero-point, that everything has as its parent.
   TrackManager* trackManager;         //!< The reference of the TrackManager that handles the course through the Level.
+  ParticleEngine* particleEngine;     //!< The ParticleEngine of the World.
   Camera* localCamera;                //!< The current Camera
-  Skysphere* skySphere;               //!< The Environmental Heaven of orxonox \todo insert this to environment insted
-  SkyBox* skyBox;
+  WorldEntity* sky;                   //!< The Environmental Heaven of orxonox \todo insert this to environment insted
   LightManager* lightMan;             //!< The Lights of the Level
   Terrain* terrain;                   //!< The Terrain of the World.
Index: orxonox/branches/openAL/src/subprojects/benchmark.cc
===================================================================
--- orxonox/branches/openAL/src/subprojects/benchmark.cc	(revision 4194)
+++ orxonox/branches/openAL/src/subprojects/benchmark.cc	(revision 4194)
@@ -0,0 +1,472 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+
+*/
+
+
+#if defined __linux__ 
+
+#include "list.h"
+#include "world_entity.h"
+#include "vector.h"
+#include "player.h"
+#include "base_object.h"
+
+#include <asm/msr.h>
+#include <linux/timex.h>
+
+
+#define LIST_MAX 1000
+#define VECTOR_MAX 1000000
+#define ITERATIONS 10000
+
+
+int startBenchmarks()
+{
+
+  printf("===========================================================\n");
+  printf("=                      BENCHMARKS                         =\n");
+  printf("===========================================================\n");
+  printf(" the author is not paying any attention to cacheing effects\n");
+  printf(" of the CPU.\n\n");
+  printf("[title]\t\t\t\t\t     [cycles]\t[loops]\n\n");
+  //  printf("------------------------------------------------------------\n\n");
+
+  // first measure the time overhead:
+  unsigned long ini, end, dt, tmp;
+  rdtscl(ini); rdtscl(end);
+  dt = end - ini;
+
+  int type = -1; 
+  /* type   -1 == all 
+     type    0 == framework
+     type    1 == vector
+     type    2 == quaternion
+     type    3 == lists
+  */
+  if(type == 0 || type == -1)
+    {
+      /* framework test*/
+      
+      printf("Generating Objects:\t\t\t\t\t%i\n", ITERATIONS);
+      /* ************WorldEntity class test************** */
+      WorldEntity* w = NULL;
+      int i = 0;
+      unsigned long mittel = 0;
+      
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  WorldEntity* w = new WorldEntity();
+	  
+	  rdtscl(end);
+	  delete w;
+	  mittel += (end - ini - dt);
+	}
+      float mi = mittel / (float)ITERATIONS;
+      printf(" Generate a WorldEntity object:\t\t%11.2f\n", mi);
+      
+      /*
+	mittel = 0;
+	for(i = 0; i < ITERATIONS; ++i)
+	{
+	rdtscl(ini);
+	
+	WorldEntity* w = new Primitive(P_SPHERE);
+	
+	rdtscl(end);
+	delete w;
+	mittel += (end - ini - dt);
+	}
+	mi = mittel / (float)ITERATIONS;
+	printf(" Generate a Primitive  object:\t\t%11.2f\n", mi);
+      */
+
+      mittel = 0;
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Vector* v = new Vector();
+	  
+	  rdtscl(end);
+	  delete v;
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)ITERATIONS;
+      printf(" Generate a Vector object:\t\t%11.2f\n", mi);
+
+
+     mittel = 0;
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Quaternion* q = new Quaternion();
+	  
+	  rdtscl(end);
+	  delete q;
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)ITERATIONS;
+      printf(" Generate a Quaternion object:\t\t%11.2f\n", mi);
+
+
+
+
+      printf("\nCalling function inline &| virtual, \t\t\t%i\n", ITERATIONS);
+      mittel = 0;
+      w = new WorldEntity();
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  w->tick(0.0f);
+
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	  }
+      //delete w;
+      mi = mittel / (float)ITERATIONS;
+      printf(" Virt funct tick() of WE: \t\t%11.2f\n", mi);
+
+
+      mittel = 0;
+      WorldEntity wo;
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  wo.tick(0.0f);
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	  }
+      //delete w;
+      mi = mittel / (float)ITERATIONS;
+      printf(" Inl virt funct tick() of WE v2: \t%11.2f\n", mi);
+
+      
+      mittel = 0;
+      BaseObject* bo = new BaseObject();
+      for(i = 0; i < ITERATIONS; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  bo->isFinalized();
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	  }
+      //delete w;
+      mi = mittel / (float)ITERATIONS;
+      printf(" Inl funct BaseObject::isFinazlized(): \t%11.2f\n", mi);
+
+      
+      tList<WorldEntity>* list = new tList<WorldEntity>();
+
+      
+      /* ************Primitvie class test************** */
+      list = new tList<WorldEntity>();
+ 
+      
+      /*
+	mittel = 0;
+	w = new Primitive(P_SPHERE);
+	for(i = 0; i < ITERATIONS; ++i)
+	{
+	rdtscl(ini);
+	
+	w->tick(0.0f);
+	
+	rdtscl(end);
+	mittel += (end - ini - dt);
+	}
+	mi = mittel / (float)ITERATIONS;
+	printf(" Call function tick() of Prim:\t\t%11.2f\n", mi);
+      */
+      
+    }
+  
+  if(type == 1 || type == -1)
+    {
+      printf("\nDoing some simple vector operations: \t\t\t%i\n", VECTOR_MAX);
+      /* vector test */
+      Vector* a = new Vector(1.3, 5.3, 4.1);
+      Vector* b = new Vector(0.4, 2.5, 6.2);
+      Vector* c = new Vector();
+      
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      // addition
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = *a + *b;
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Addition of two vectors:\t\t%11.2f\n", mi);
+      
+      // multiplikation
+
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = a->cross( *b);
+	   
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" CrossMult of two vectors:\t\t%11.2f\n", mi);
+
+    }
+  if( type == 2 || type == -1)
+    {
+      /* quaternion test */
+      printf("\nDoing some simple quaternion operations: \t\t%i\n", VECTOR_MAX);
+      /* vector test */
+      Quaternion* a = new Quaternion();
+      Quaternion* b = new Quaternion();
+      Quaternion* c = new Quaternion();
+      
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      // quaternion generieren mit spez konstruktor
+      mittel = 0;
+      Vector* qa = new Vector(4.6, 9.3, 0.4);
+      Vector* qb = new Vector(3.5, 6.1, 4.3);
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Quaternion* qu = new Quaternion(*qa, *qb);
+	  
+	  rdtscl(end);
+	  delete qu;
+	  mittel += (end - ini - dt);
+	}
+      delete a;
+      delete b;
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Gen. quatern. betw. two vectors:\t%11.2f\n", mi);
+      
+      
+      // multiplication
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = *a * *b;
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Multiplying two quat.(=rot): a * b\t%11.2f\n", mi);
+      
+      
+      
+      // rotating a vector by a quaternion
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *qa = a->apply(*qb);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Rot a vec by a quat: q->apply(v)\t%11.2f\n", mi);
+      
+      
+      
+      // generate rotation matrix
+      mittel = 0;
+      float matrix[4][4];
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  a->matrix(matrix);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Generate rot matrix: q->matrix(m)\t%11.2f\n", mi);
+    }
+  if( type == 3 || type == -1)
+    {
+      /* list tests*/
+      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
+      tList<char>* list = new tList<char>();
+      char* name;
+      
+      printf(" Adding[1..10] elements to list, found:\n");
+      list->add("1");
+      list->add("2");
+      list->add("3");
+      list->add("4");
+      list->add("5");
+      list->add("6");
+      list->add("7");
+      list->add("8");
+      list->add("9");
+      list->add("10");
+      
+      /*give list out */
+      tIterator<char>* iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
+	  name = iterator->nextElement();
+	}
+      delete iterator;
+      printf("\n");
+      
+      
+      /*removing some elements from the list*/
+      printf(" Removing elements [2,3,6,8,10], adding [11] now found:\n");
+      list->remove("2");
+      list->remove("3");
+      list->remove("6");
+      list->remove("8");
+      list->remove("10");
+      list->add("11");
+      /*give list out */
+      iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
+	  name = iterator->nextElement();
+	}
+      delete iterator;
+      printf("\n");
+      
+      delete list;
+      printf("\nChecking list performance:\t\t\t\t%i\n", LIST_MAX);
+      
+      tList<int>* plist = new tList<int>();
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      mittel = 0;
+      for(i = 0; i < LIST_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  plist->add(&i);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)LIST_MAX;
+      printf(" Adding reference to list:\t\t%11.2f\n", mi);
+      
+      mittel = 0;
+      for(i = 0; i < LIST_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  plist->remove(&i);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)LIST_MAX;
+      printf(" Removing 1st reference from list:\t%11.2f\n", mi);
+      
+
+      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
+      list = new tList<char>();
+      printf(" Adding[1..10] elements to list, found:\n");
+      list->add("1");
+      list->add("2");
+      list->add("3");
+      list->add("4");
+      list->add("5");
+      list->add("6");
+      list->add("7");
+      list->add("8");
+      list->add("9");
+      list->add("10");
+      
+      /*give list out */
+      iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
+	  name = iterator->nextElement();
+	}
+      delete iterator;
+      printf("\n");
+      
+      
+      int c = 0;
+      printf(" Going trough list with nextElement(el) func: ");
+      name = list->firstElement();
+      while(c < 20)
+	{
+	  printf("%s,", name);
+	  name = list->nextElement(name);
+	  c++;
+	}
+      printf("\n");
+      
+
+      
+    }
+  
+}
+
+#else
+
+#include "debug.h"
+
+int startBenchmarks()
+{
+  PRINTF(1)("Benchmark is not implemented in this system\n");
+}
+
+#endif
Index: orxonox/branches/openAL/src/subprojects/benchmark.h
===================================================================
--- orxonox/branches/openAL/src/subprojects/benchmark.h	(revision 4194)
+++ orxonox/branches/openAL/src/subprojects/benchmark.h	(revision 4194)
@@ -0,0 +1,13 @@
+/*! 
+    \file benchmark.h
+    \brief benchmark functions
+*/ 
+
+
+#ifndef _BENCHMARK_H
+#define _BENCHMARK_H
+
+int startBenchmarks(void);
+
+
+#endif /* _BENCHMARK_H */
Index: orxonox/branches/openAL/src/track_manager.cc
===================================================================
--- orxonox/branches/openAL/src/track_manager.cc	(revision 3921)
+++ orxonox/branches/openAL/src/track_manager.cc	(revision 4194)
@@ -312,5 +312,5 @@
   PNode* tmpNode = (PNode*)node;
 
-  if (tmpNode->getRelCoor()->z < 0)
+  if (tmpNode->getRelCoor().z < 0)
     return 0;
   else 
@@ -333,5 +333,5 @@
   PNode* tmpNode = (PNode*)node;
 
-  Vector nodeRelCoord = *tmpNode->getRelCoor();
+  Vector nodeRelCoord = tmpNode->getRelCoor();
   float minDist = 100000000;
   int childNumber = 0;
@@ -396,4 +396,17 @@
   this->textAnimation->setInfinity(ANIM_INF_CONSTANT);
 }
+
+
+/**
+   \brief loads a trackElement from a TiXmlElement
+   \param root the TiXmlElement to load the Data from
+
+*/
+bool TrackManager::load( TiXmlElement* root)
+{
+
+}
+
+
 
 /**
Index: orxonox/branches/openAL/src/track_manager.h
===================================================================
--- orxonox/branches/openAL/src/track_manager.h	(revision 3921)
+++ orxonox/branches/openAL/src/track_manager.h	(revision 4194)
@@ -153,4 +153,6 @@
   static TrackManager* getInstance(void);
 
+  bool load(TiXmlElement* root);
+
   // Methods to change the Path (initialisation)
   void workOn(unsigned int trackID);
Index: orxonox/branches/openAL/src/track_node.cc
===================================================================
--- orxonox/branches/openAL/src/track_node.cc	(revision 3921)
+++ orxonox/branches/openAL/src/track_node.cc	(revision 4194)
@@ -41,10 +41,10 @@
 
 
-TrackNode::TrackNode (Vector* absCoordinate)
+TrackNode::TrackNode (const Vector& absCoordinate)
 {
   this->parent = NullParent::getInstance();
   this->trackManager = TrackManager::getInstance();
   this->setMode(PNODE_ALL);
-  this->absCoordinate = absCoordinate;
+  this->setAbsCoor(absCoordinate);
 }
 
Index: orxonox/branches/openAL/src/track_node.h
===================================================================
--- orxonox/branches/openAL/src/track_node.h	(revision 3921)
+++ orxonox/branches/openAL/src/track_node.h	(revision 4194)
@@ -22,5 +22,5 @@
  public:
   TrackNode ();
-  TrackNode (Vector* absCoordinate);
+  TrackNode (const Vector& absCoordinate);
 
   virtual ~TrackNode ();
Index: orxonox/branches/openAL/src/util/animation/animation.cc
===================================================================
--- orxonox/branches/openAL/src/util/animation/animation.cc	(revision 3921)
+++ orxonox/branches/openAL/src/util/animation/animation.cc	(revision 4194)
@@ -34,6 +34,7 @@
 
   // setting default values
+  this->keyFramesToPlay = -1;
   this->localTime = 0.0;
-  this->bRunning = true;
+  this->bRunning = false;
 
   AnimationPlayer::getInstance()->addAnimation(this);
@@ -83,5 +84,6 @@
       break;
     case ANIM_INF_REPLAY:
-      this->replay();
+      this->rewind();
+      this->bRunning = true;
       break;
     case ANIM_INF_REWIND:
@@ -99,4 +101,15 @@
 void Animation::play()
 {
+  this->keyFramesToPlay = -1;
+  this->bRunning = true;
+}
+
+/**
+   \brief plays the Next n keyframes
+   \param n the Count of keyFrames to play.
+*/
+void Animation::playNextKeyframes(int n)
+{
+  this->keyFramesToPlay = n-1;
   this->bRunning = true;
 }
@@ -107,4 +120,5 @@
 void Animation::stop()
 {
+  this->keyFramesToPlay = -1;
   this->rewind();
   this->bRunning = true;
@@ -127,4 +141,4 @@
 {
   this->rewind();
-  this->bRunning = true;
+  this->play();
 }
Index: orxonox/branches/openAL/src/util/animation/animation.h
===================================================================
--- orxonox/branches/openAL/src/util/animation/animation.h	(revision 3921)
+++ orxonox/branches/openAL/src/util/animation/animation.h	(revision 4194)
@@ -25,5 +25,7 @@
    ANIM_NEG_EXP: fast, slow
    ANIM_RANDOM: eratic
-   
+
+   ANIM_NULL: !!DO NOT USE THIS!! only for internal handling
+
    deprecated QUADRATIC
 */
@@ -35,5 +37,7 @@
 			    ANIM_NEG_EXP,
 			    ANIM_QUADRATIC,
-			    ANIM_RANDOM};
+			    ANIM_RANDOM,
+			    ANIM_NULL};
+#define ANIM_DEFAULT_FUNCTION ANIM_LINEAR      //!< A default function to choose from the above set
 
 //! An enumerator describing what the animation should do after the last keyframe.
@@ -69,4 +73,5 @@
 
   void play(); // equals resume();
+  void playNextKeyframes(int n = 1);
   void stop();
   void pause();
@@ -95,4 +100,5 @@
   BaseObject* baseObject;         //!< The same as object in the derived classes, but with reference to BaseObject
   unsigned int keyFrameCount;     //!< The Count of KeyFrames.
+  int keyFramesToPlay;            //!< How many more Keyframes to play. if negative it will be ignored if 0 stop.
   bool bHandled;                  //!< If this Animation is handled by the AnimationPlayer.
   bool bRunning;                  //!< If the animation is running
